/***************************************************************************
 *
 * Copyright (C) 2005 Elad Lahav (elad_lahav@users.sourceforge.net)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ***************************************************************************/

#ifndef GRAPHVIZ_H
#define GRAPHVIZ_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

class GraphWidget;

#define _PACKAGE_ast	0
#define _dll_import		0
#define _DLL_BLD		0
#define _BLD_cdt		0
#define _hdr_stddef		0
#define _hdr_stdarg		0
#define _hdr_varargs	0

#ifdef GRAPHVIZ_2_2

#include <dotneato.h>
#include <pack.h>

#else

#include <gvc.h>
#include <geom.h>

// NOTE:
// Defined here instead of including pack.h which depends on the non-
// distributed file render.h
// This bug was already fixed in Graphviz, but the fix may not have propagated
// to all distributions.
extern "C" {
extern Agraph_t **ccomps(Agraph_t *, int *, char *);
}

#endif /* GRAPHVIZ_2_2 */

namespace Graphviz
{
	void init(char**);	
	void fini();
	void draw(GraphWidget*);
	void save(GraphWidget*, FILE*);
}

#endif /* GRAPHVIZ_H */
